clear all 
close all

%% transfer function in constant time

% G= mu*(1+s*tau)/(1+s*T); mu is the gain 

%% es 1
% GRUPPO A

% tf 1
num1=[2];
den1=[3, 1];
sist1=tf(num1,den1);
%first order response of a scrictly proper sistem 


% tf 2
s=tf('s');
sist2=2*(s+1)/(3*s+1);
% first order response con zero sinistro


% tf 3
sist3=2*(1-s)/(3*s+1);
% first order response con zero destro

% avendo tutte e tre le tf la stessa costante di tempo convergono al valore
% di regime contemporaneamente, nonostante partissero da punti diversi di
% uscita (lo stato iniziale  comunque 0 in tutti i casi). 

% n.b.: non sto plottando l'andamento dello stato bens quello dell'uscita,
% ecco perch l'origine non sempre appartiene al grafico (in particolare
% per tf2 e tf3 che sono sistemi propri e non strettamente propri).
figure
step(sist1)
hold on
step(sist2)
step(sist3)
legend('G_1','G_2','G_3')
title('Gruppo A')


% GRUPPO B

% tf 4
sist4=2/((5*s + 1)*(s + 1));
% second order response: (s+1) polo veloce che esaurisce la sua risposta in 5*T1=5s, 
%                        (5*s+1) polo lento che esaurisce la sua risposta in 5*T2=25s, 
%il tempo di assestamento non pu essere calcolato semplicemente come
%funzione di T1 e T2 ma se T2>>T1 allora approx dominante


% tf 5
sist5=2/(5*s+1);
% first-order (approssimazione a polo dominante di G4)

figure
step(sist4)
hold on
step(sist5)
legend('G_4','G_5')
title('Gruppo B')


% GRUPPO C

% tf 6
s=tf('s');
sist6=2/(5*s+1)^2;
% due poli reali coincidenti (T1=T2). Posso calcolare tempo assestamento
% esplicitamente T_{a5}=4.74*T, dove T=T1=T2

% tf 7
sist7=2*(30*s+1)/(5*s+1)^2;
% due poli reali coincidenti e uno zero con tau>T1=T2 -> sovraelongazione
% (tanto pi marcata quanto pi grande  il valore di tau).

% tf 8
sist8=2*(1-30*s)/(5*s+1)^2;
% due poli reali coincidenti e uno zero con tau<0 -> risposta inversa
% (tanto pi pronunciata quanto pi |tau|  grande).

figure
step(sist6)
hold on
step(sist7)
step(sist8)
legend('G_6','G_7','G_8')
title('Gruppo C')

